//+------------------------------------------------------------------+
//|                                   ScriptSample_CustZigZagPPC.mq5 |
//|                                         Copyright 2011, AlexSTAL |
//|                                           http://www.alexstal.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright 2011, AlexSTAL"
#property link      "http://www.alexstal.ru"
#property version   "1.00"

#include <ZigZags.mqh>

CCustPrevCalculated CustPrevCalculated;
CCustZigZagPPC ZZ1, ZZ2;

void OnStart()
  {
   //      
   CustPrevCalculated.InitData(_Symbol, _Period, 150, CPCHSM_Normal, CPCH_high|CPCH_low, 15);
   
   //   ZZ
   ZZ1.Init(GetPointer(CustPrevCalculated), _Symbol, _Period, 150, CPCHSM_Normal, CPCH_high|CPCH_low, 15, 0, true, 12, 10);
   ZZ2.Init(GetPointer(CustPrevCalculated), _Symbol, _Period, 150, CPCHSM_Normal, CPCH_high|CPCH_low, 15, 0, true, 20, 10);
   
   //  
   CPCPrepareDataResultCode resData, resZZ1, resZZ2;
   resData = CustPrevCalculated.PrepareData();
   
   //     ! PrepareData   !
   resZZ1 = ZZ1.PrepareData(resData);
   resZZ2 = ZZ2.PrepareData(resData);
   
   //   ZZ1
   if ( (resZZ1 != CPCPDRC_NoData) && (resZZ1 != CPCPDRC_NoRecountNotRequired) )
     {
      Print("  ZZ1: ", EnumToString(ZZ1.Calculate()));
      for (int i = (int)(ZZ1.GetBarsCalculated()-1); i >= 0; i--)
        {
         double tmpDN = ZZ1.GetDN(i, false);
         double tmpUP = ZZ1.GetUP(i, false);
         datetime tmpTime = CustPrevCalculated.GetDataTime(i, false);
         if (tmpDN != EMPTY_VALUE)
            Print(TimeToString(tmpTime), " : ", tmpDN);
         if (tmpUP != EMPTY_VALUE)
            Print(TimeToString(tmpTime), " : ", tmpUP);
        }
     }
   //   ZZ2
   if ( (resZZ2 != CPCPDRC_NoData) && (resZZ2 != CPCPDRC_NoRecountNotRequired) )
     {
      Print("  ZZ2: ", EnumToString(ZZ2.Calculate()));
      for (int i = (int)(ZZ2.GetBarsCalculated()-1); i >= 0; i--)
        {
         double tmpDN = ZZ2.GetDN(i, false);
         double tmpUP = ZZ2.GetUP(i, false);
         datetime tmpTime = CustPrevCalculated.GetDataTime(i, false);
         if (tmpDN != EMPTY_VALUE)
            Print(TimeToString(tmpTime), " : ", tmpDN);
         if (tmpUP != EMPTY_VALUE)
            Print(TimeToString(tmpTime), " : ", tmpUP);
        }
     }
  }